#include "pdbml.h"


#define Create_table_athlete    "create table %s (num_ath int  not null,nom char(30), prenom char(30), Adresse char(50), Ville char(30))"
#define Create_table_lieu        "create table %s (code_lieu int not null,nom char(30), Adresse char(50), Ville char(30))"
#define Create_table_competition "create table %s (code_comp int  not null,code_lieu int , sport char(30), date_comp date )"
#define Create_table_participant "create table %s (num_ath int not null, code_comp int  not null)"


     
/**** zipff :  fonction  qui messure le desequilibre de la distribution des valeurs  d'un attribut *****/
/*static int zipff(size, value, theta, i)*/
static double zipff_coef(value, theta)
     int value;
     double theta;
{
    int j;
    double freq=0.0;
    for (j=1; j<=value;j++) freq += 1.0/pow((double) j,theta);
    return freq;
}

static int zipff(size,freq,theta, i)
     int size,i;
     double theta,freq;
{
  double freq1;
  freq1= ((double) (size))/(pow((double) i,theta)*freq);
  return (rint(freq1));
}


static int hash(int i,int n)
{ 
   return (i % n);  
}

int load_local_double_indexed_files(sfile,table,nprocs,myid,nodes_id,sock,com) 
     __String  table, sfile;
     int       nprocs,myid,*nodes_id;
     MYSQL     *sock;
     MPI_Comm  com; 
{
__Query tmp_file,comm;    
   int i,id,err=1; 
  
 id=nodes_id[myid];
 for (i=0;i<nprocs;i++){
      sprintf(tmp_file,"%s/%s_%d_%d.data",host[id].path,sfile,i,myid);
      sprintf(comm, "LOAD DATA INFILE '%s' INTO TABLE %s FIELDS Terminated by ','",tmp_file,table); 
      if (mysql_query(sock,comm)){ 
         fprintf(stderr," On %s :%s not done !\n",host[id].name,comm); 
         err=0;
       } 
      /* if (i!=0) unlink(tmp_file); */
 }
 return(err);
}
int exchange_double_indexed_files(table,nprocs,myid,nodes_id,sock,com) 
     __String table;
     int      nprocs,myid,*nodes_id;
     MYSQL    *sock;
     MPI_Comm com; 
{ 
int   err=1; 
    
    send_double_idx_files(table,table,myid,nprocs,nodes_id,com);
    MPI_Barrier(com);
    err=load_local_double_indexed_files(table,table,nprocs,myid,nodes_id,sock,com) ;
    return(err);
}



/*****  init_insert : cree un fichier de frequence  (genere' de maniere aletoire) pour la table externe *****/   

void init_insert(size,distinct_values,zip_value,decal,corr,nprocs,hist_file)
     int size,distinct_values,decal,corr,nprocs;
     double zip_value;
     char   *hist_file;
     
{  __Query tmp_file;
   int  i,count=0,num,j,k,procs,total=0;
   char record[80];
   HIST hist;
   HIST_LINK *data;
   FILE *fd;
   double zc;

   init_hosts(host,NODES_CONFIG_FILE,&NODES_NUMBER);
   if (hist_init(&hist,distinct_values,0,0,get_key,free_record))
     exit(0);
     
   zc=zipff_coef(distinct_values,zip_value);
   for (i=1;i<distinct_values;i++){
       num=zipff(size,zc,zip_value,i);  
       if (i<=corr){ 
	   sprintf(record,"%d",i+decal);
	   if (hist_insert_frequency(&hist,record,num))
	       fprintf(stderr,"\n record :'%s  freq :%d' non insere'",record,num);
       } else {
	   k=randomize(4*distinct_values);
	   sprintf(record,"%d",k+decal);
	   if (hist_insert_frequency(&hist,record,num))
	       fprintf(stderr,"\n record :'%s  freq :%d' non insere'",record,num);        
       }
       total+=num;
   }
 
   if (size>total) {
       sprintf(record,"%d",distinct_values+decal);
       if (hist_insert_frequency(&hist,record,size-total))
	   fprintf(stderr,"\n record :'%s  freq :%d' non insere'",record,size-total);
   }
   
   /* show_hist(&hist); */ 
    //sprintf(tmp_file,"%s/%s",host[id].path,hist_file);
    if ((fd=fopen(hist_file,"wt"))==NULL) {
       fprintf(stderr,"\n can't open %s ",hist_file);
       exit(0);
     }
     data=array_dynamic_element(&hist.array,0,HIST_LINK*);
     for (j=0,count=hist.records ; j < count ; j++)
       fprintf(fd,"%s %d\n",data[j].data,data[j].freq);
     fclose(fd);      
   
   hist_free(&hist);
 } 


void insert_table_athlete( name, size,nprocs,myid,nodes_id,sock,Comm)  
     char   *name;
     int size,nprocs, myid,*nodes_id;
     MYSQL *sock;
     MPI_Comm Comm;
{ __Query qbuf,table,*tmp_file,tmp_file1,buf;
  int  count=0, num,i,j,procs,total=0, id;
  FILE **fd;
  

   sprintf(table,"%s",name);
   //sprintf(table,"%s_%d",name,myid);
   sprintf(qbuf,Create_table_athlete,table);
   if (mysql_query(sock,qbuf)){
     fprintf(stderr,"\n  Table %s not created ...",name);
     exit(0);
   }
   tmp_file=(__Query*) malloc(sizeof(__Query)*nprocs);
   fd = (FILE**)  malloc(sizeof(FILE*) *nprocs);
   
   id=nodes_id[myid];
   for (i=0; i<nprocs;i++) {          
     sprintf(tmp_file[i],"%s/%s_%d_%d.data",host[id].path,name,myid,i); 
    if ((fd[i]=fopen(tmp_file[i],"wt"))==NULL) {
         fprintf(stderr," can't open %s \n",tmp_file);
         exit(0);
       }
  }
  for (i=0; i<size; i++){ 
	     procs=randomize(nprocs); 
             sprintf(buf,"%d,'AA%d','AAA%d', 'Ad%d','V%d'\n",i,i,i,randomize(size/10),randomize(size/10) ) ;
	     if (!(fprintf(fd[procs],buf)))
	          fprintf(stderr,"row %d  not inserted\n",i) ;
      } 
     
    for (i=0; i<nprocs;i++)  fclose(fd[i]);
    free(fd); free(tmp_file);
    
    MPI_Barrier(Comm);
    if ((exchange_double_indexed_files(name,nprocs,myid,nodes_id,sock,Comm))==0)
	 fprintf(stderr,"exchange_double_indexed_files not done\n");  
    MPI_Barrier(Comm);
}

void insert_table_lieu( name, size,nprocs,myid,nodes_id,sock,Comm)  
     char   *name;
     int size,nprocs, myid,*nodes_id;
     MYSQL *sock;
     MPI_Comm Comm;
{ __Query qbuf,table,*tmp_file,tmp_file1,buf;
  int  count=0, num,i,j,procs,total=0, id;
  FILE **fd;
  

   sprintf(table,"%s",name);
   //sprintf(table,"%s_%d",name,myid);
   sprintf(qbuf,Create_table_lieu,table);
   if (mysql_query(sock,qbuf)){
     fprintf(stderr,"\n  Table %s not created ...",name);
     exit(0);
   }
   tmp_file=(__Query*) malloc(sizeof(__Query)*nprocs);
   fd = (FILE**)  malloc(sizeof(FILE*) *nprocs);
   
   id=nodes_id[myid];
   for (i=0; i<nprocs;i++) {          
     sprintf(tmp_file[i],"%s/%s_%d_%d.data",host[id].path,name,myid,i); 
    if ((fd[i]=fopen(tmp_file[i],"wt"))==NULL) {
         fprintf(stderr," can't open %s \n",tmp_file);
         exit(0);
       }
  }
  for (i=0; i<size; i++){ 
	     procs=randomize(nprocs); 
             sprintf(buf,"%d,'L%d','Ad%d','V%d'\n",i,i,randomize(size/10),randomize(size/10)) ;
	     if (!(fprintf(fd[procs],buf)))
	          fprintf(stderr,"row %d  not inserted\n") ;
      } 
     
  
    for (i=0; i<nprocs;i++)  fclose(fd[i]);
    free(fd); free(tmp_file);
    
    MPI_Barrier(Comm);
    if ((exchange_double_indexed_files(name,nprocs,myid,nodes_id,sock,Comm))==0)
	 fprintf(stderr,"exchange_double_indexed_files not done\n");  
    MPI_Barrier(Comm);
}

                             
void insert_table_competition( name, size,distinct_values, nprocs,zip_value, myid,nodes_id,sock,Comm)  
     char   *name;
     int size,distinct_values,nprocs, myid,*nodes_id;
     MYSQL *sock;
     double zip_value;
     MPI_Comm Comm;
{
    __Query qbuf,table,*tmp_file,tmp_file1,buf;
    int  count=0, nb, num,i,j,procs,total=0, id;
    FILE **fd;
    double zc;

    sprintf(table,"%s",name);
    //sprintf(table,"%s_%d",name,myid);
    sprintf(qbuf,Create_table_competition,table);
    if (mysql_query(sock,qbuf)){
	fprintf(stderr,"\n  Table %s not created ...",name);
	exit(0);
    }
    tmp_file=(__Query*) malloc(sizeof(__Query)*nprocs);
    fd = (FILE**)  malloc(sizeof(FILE*) *nprocs);
   
    id=nodes_id[myid];
    for (i=0; i<nprocs;i++) {          
	sprintf(tmp_file[i],"%s/%s_%d_%d.data",host[id].path,name,myid,i); 
	if ((fd[i]=fopen(tmp_file[i],"wt"))==NULL) {
	    fprintf(stderr," can't open %s \n",tmp_file);
	    exit(0);
	}
    }
    //printf("avant zipf\n");
    //printf("id %d ,size %d, dv %d, zv %f,nprocs %d\n",myid,size,distinct_values,zip_value,nprocs);
    i=1; 
    zc=zipff_coef(distinct_values,zip_value);
    num=zipff(size,zc,zip_value,1);
    while ((num>0) && (i<distinct_values)){  
	if (myid==hash(i,nprocs)){
	    nb=randomize(distinct_values);   
         for (j=0; j<num; j++){
	     procs=randomize(nprocs); 
             sprintf(buf,"%d, %d,'Sp%d',''\n",i,nb,randomize(distinct_values)) ;
	     //printf("%d, %d,'Sp%d','', %d\n",i,nb,randomize(distinct_values),myid) ;
	     if (!(fprintf(fd[procs],buf)))
	          fprintf(stderr,"row %d  not inserted\n",i) ;
	 }
	} 
     i++;
     total+=num;
      
      num=zipff(size,zc,zip_value,i); 
  }
  //printf("apres zipf 1 %d\n",myid);
   

   if (myid==hash(distinct_values,nprocs))
    for (j=0; j<size-total; j++){
      procs=randomize(nprocs);
      nb=randomize(distinct_values);  
      sprintf(buf,"%d, %d,'Sp%d',''\n",i,nb,randomize(distinct_values)) ;
      if (!(fprintf(fd[procs],buf)))
	          fprintf(stderr,"row %d  not inserted\n",i) ;
      i++;
    }
    for (i=0; i<nprocs;i++)  fclose(fd[i]);
    free(fd); free(tmp_file);
    //printf("apres zipf 2\n");
    
    MPI_Barrier(Comm);
    if ((exchange_double_indexed_files(name,nprocs,myid,nodes_id,sock,Comm))==0)
	 fprintf(stderr,"exchange_double_indexed_files not done\n");  
    MPI_Barrier(Comm);
   
}


void insert_table_participant( name, size,distinct_values, nprocs,zip_value, myid,nodes_id,sock,Comm)  
     char   *name;
     int size,distinct_values,nprocs, myid,*nodes_id;
     MYSQL *sock;
     double zip_value;
     MPI_Comm Comm;
{ __Query qbuf,table,*tmp_file,tmp_file1,buf;
  int  count=0, nb, num,i,j,procs,total=0, id;
  FILE **fd;
  double zc;

    sprintf(table,"%s",name);
   //sprintf(table,"%s_%d",name,myid);
   sprintf(qbuf,Create_table_participant,table);
   if (mysql_query(sock,qbuf)){
     fprintf(stderr,"\n  Table %s not created ...",name);
     exit(0);
   }
   tmp_file=(__Query*) malloc(sizeof(__Query)*nprocs);
   fd = (FILE**)  malloc(sizeof(FILE*) *nprocs);
   
   id=nodes_id[myid];
   for (i=0; i<nprocs;i++) {          
     sprintf(tmp_file[i],"%s/%s_%d_%d.data",host[id].path,name,myid,i); 
    if ((fd[i]=fopen(tmp_file[i],"wt"))==NULL) {
         fprintf(stderr," can't open %s \n",tmp_file);
         exit(0);
       }
  }

  i=1; 

  zc=zipff_coef(distinct_values,zip_value);
  num=zipff(size,zc,zip_value,1);
  while ((num>0) && (i<distinct_values)){  
    if (myid==hash(i,nprocs)){
      // nb=randomize(distinct_values);   
         for (j=0; j<num; j++){
	     procs=randomize(nprocs); 
             sprintf(buf,"%d, %d\n",i,randomize(distinct_values)) ;
	     if (!(fprintf(fd[procs],buf)))
	          fprintf(stderr,"row %d  not inserted\n",i) ;
	 } 
    }
     total+=num;
      i++;
      num=zipff(size,zc,zip_value,i); 
  }
  
 if (myid==hash(distinct_values,nprocs))
    for (j=0; j<size-total; j++){
      procs=randomize(nprocs);
      //nb=randomize(distinct_values);  
      sprintf(buf,"%d, %d\n",i,randomize(distinct_values)) ;
      if (!(fprintf(fd[procs],buf)))
	          fprintf(stderr,"row %d  not inserted\n",i) ;
      i++;
    }

   
    for (i=0; i<nprocs;i++)  fclose(fd[i]);
    free(fd); free(tmp_file);
    
    MPI_Barrier(Comm);
    if ((exchange_double_indexed_files(name,nprocs,myid,nodes_id,sock,Comm))==0)
	 fprintf(stderr,"exchange_double_indexed_files not done\n");  
    MPI_Barrier(Comm);
}



void create_database2_tables(db_name,name1,size1,name2,size2,name3, size3,dist_values3,zip_value3,name4, size4,dist_values4,zip_value4,nprocs, myid,nodes_id, sock,Comm,ffile) 
      char   *db_name,*name1,*name2,*name3,*name4,*ffile;
     int
             size1,size2,size3,size4,
             dist_values3,dist_values4,
             nprocs, myid,*nodes_id;
     double  zip_value3,zip_value4;
     MYSQL   *sock;
     MPI_Comm Comm;    
     
{ 
double   startwtime, endwtime;
 int id;  
   startwtime = MPI_Wtime();   
   char sysstr[100];

   printf("creation de la base %s sur %d\n",db_name,myid);
     if (mysql_create_db(sock,db_name)){ 
      fprintf(stderr,"\n Couldn't create database %s on processor : %d !\n %s\n ",db_name,myid,mysql_error(sock));
      MPI_Finalize(); 
      exit(1);
    }
    
  id=nodes_id[myid];
  if (mysql_select_db(sock,db_name)) {
    fprintf(stderr,"\n Couldn't select database %s on %s !\n %s\n ",db_name,
                        (host+id)->name,mysql_error(sock));
    MPI_Finalize(); 
    exit(1);
  }
  sprintf(sysstr,"rm -f %s/",host[id].path);
  strcat(sysstr,"*.data");

   printf("creation de la table %s sur %d\n",name1,myid);
  insert_table_athlete     ( name1, size1,nprocs,myid,nodes_id,sock,Comm)  ;
  MPI_Barrier(Comm); 
  system(sysstr);

   printf("creation de la table %s sur %d\n",name2,myid);
  insert_table_lieu        ( name2, size2,nprocs,myid,nodes_id,sock,Comm)  ;
  MPI_Barrier(Comm); 
  system(sysstr);

    printf("creation de la table %s sur %d\n",name3,myid);
 insert_table_competition ( name3, size3,dist_values3, nprocs,zip_value3, myid,nodes_id,sock,Comm)  ;
  MPI_Barrier(Comm); 
  system(sysstr);

   printf("creation de la table %s sur %d\n",name4,myid);
  insert_table_participant ( name4, size3,dist_values4, nprocs,zip_value4, myid,nodes_id,sock,Comm)  ;
  MPI_Barrier(Comm);
  system(sysstr);


  if (myid == 0) {     
    endwtime = MPI_Wtime();
    fprintf(stderr,"\n Database %s created in %f sec.\n",db_name,endwtime-startwtime);  
  }
   
}



int main(argc,argv)
int argc;
char *argv[];
{  

  MYSQL       *sock,connect;	
  MYSQL_RES   *msresult;
  MYSQL_ROW    row;
 
  __Query      qbuf,comm;
  __String     name, db_name,sj_name,
               speed_up_file, avs_file, jps_file;

  int          num_procs, myid,id, namelen,nodes_id[Max_nodes];

 uint         scount  ,fcount,  efcount, 
              Max_std_join, Max_fa_join, Max_efa_join,              
              nbucket,threshold,idx, R_size,S_size,
              r_size, r_dist_values,
              size1, size2,size3,size4, dist_values3, dist_values4,
              s_size, s_dist_values, decal,corr,count; 
  double     std_loc_time, std_time, std_JP_avg, std_JP_dev, ssum,
             efa_loc_time, efa_time, efa_JP_avg, efa_JP_dev, efsum, 
              fa_loc_time,  fa_time,  fa_JP_avg,  fa_JP_dev, fsum,
               startwtime, endwtime, join_select, total, sum,
               r_theta, s_theta,
               zipf3, zipf4;    

  FILE        *speed_up, *avs, *jps;  
  char        processor_name[64],*user_name, *password,*host_name;      
	           	
  MPI_Init(&argc,&argv);
  MPI_Comm_size(MPI_COMM_WORLD,&num_procs);
  MPI_Comm_rank(MPI_COMM_WORLD,&myid);
  MPI_Get_processor_name(processor_name,&namelen); 
         if (!((argc ==12))) {
	 if (myid == 0){
             fprintf(stderr,"\n usage : create_db <dbname> <size1> <size2> <size3> <dist_values3> <zipf3> <size4> <dist_values4> <zipf4> <decal> <corr> \n\n"); 
	 }
         MPI_Finalize(); 
	 exit(1);
       }
	   if (myid == 0) {
               fprintf(stderr," Processes number : %d\n",num_procs);
               fprintf(stderr," Database name    : %s\n ", argv[1]);
           }
           strcpy(db_name,argv[1]);
           size1        = atoi(argv[2]);
           size2        = atoi(argv[3]);           
	   size3        = atoi(argv[4]);
	   dist_values3 = atoi(argv[5]);
	   zipf3        = atof(argv[6]);
	   size4        = atoi(argv[7]);
	   dist_values4 = atoi(argv[8]);
	   zipf4        = atof(argv[9]);
           decal         = atoi(argv[10]); 
           corr         = atoi(argv[11]);
           startwtime = MPI_Wtime(); 
      
	   //init_hosts();
  init_hosts(host,NODES_CONFIG_FILE,&NODES_NUMBER);
  id=host_id(processor_name);
  MPI_Allgather(&id,1, MPI_INT,nodes_id,1,MPI_INT,MPI_COMM_WORLD); 
  
  MPI_Barrier(MPI_COMM_WORLD);



  // if (myid==0)
  //    init_insert(s_size,s_dist_values,s_theta,decal,corr,num_procs,FREQ_FILE);
  //if (!(sock = mysql_connect(&connect,"localhost",MYSQL_USER,MYSQL_PASSWORD))){ 
  //  fprintf(stderr,"\n Couldn't connect to mysql  server on %s!\n ",processor_name);
  //  MPI_Finalize(); 
  //  exit(1);
  //}

  mysql_port=(host+id)->port;
  user_name=(host+id)->username;
  password=(host+id)->password;
  host_name=(host+id)->name; 

  if (!(sock = mysql_connect(&connect,host_name,user_name,password))){ 
       fprintf(stderr,"\n Couldn't connect to mysql  server on %s!\n ",processor_name);
       MPI_Finalize(); 
       exit(1);
  }


  MPI_Barrier(MPI_COMM_WORLD);
  
  
  create_database2_tables(db_name,"athlete",size1,"lieu",size2,"comp", size3,dist_values3,zipf3,"part", size4,dist_values4,zipf4,num_procs, myid,nodes_id, sock,MPI_COMM_WORLD,FREQ_FILE) ;

  fprintf(stderr,"prepare flush\n");
 
  /* if (mysql_query(sock,"FLUSH TABLES")){ 
    fprintf(stderr,"\n Refresh tables not done ...\n");
    }*/
  
  /*------------------------------------------------------------------------------*/
  fprintf(stderr,"prepare synchro\n");
  MPI_Barrier(MPI_COMM_WORLD);

  fprintf(stderr,"fermeture bd\n");
  mysql_close(sock);     
  fprintf(stderr,"fermeture mpi\n");

  MPI_Finalize(); 
  fprintf(stderr,"fin\n");

}





