#include <caml/mlvalues.h>
#include <caml/memory.h>
#include <caml/custom.h>
#include <caml/fail.h>
#include "odbc/odbc.h"
#include "proto/interface.h"

struct custom_operations * ops;

void init_ops () {
  ops=(struct custom_operations*)malloc(sizeof(struct custom_operations));
  ops->identifier=NULL;
  ops->finalize=NULL;
  ops->compare=custom_compare_default;
  ops->hash=custom_hash_default;
  ops->serialize=custom_serialize_default;
  ops->deserialize=custom_deserialize_default;
}


// Execute la requete. Retourne le nom de la table produite
CAMLprim value dbml_exec_stub(value file,value db,value np) {
  CAMLparam3(file,db,np);
  CAMLlocal2(relname,syschaine);
  //appeler le main du programme de calcul
  printf("dans dbml_exec\n");

  syschaine=alloc_string(256);
  sprintf((char*)syschaine,"mpirun -nolocal -np %s -machinefile mpinodes.conf parquery %s %s",(char*)np,(char*)db,(char*)file);
  
  printf("%s\n",syschaine);
  system((char*)syschaine);

  relname=alloc_string(15);
  strcpy((char*)relname,"table_result");
  //relname=(value)get_rel_name((char*)relname,(char*)file);
  CAMLreturn (relname);
}

// Ouvre un curseur vers la bd situee sur un noeud donn.
// Retourne le curseur
CAMLprim value dbml_open_node_cursor_stub(value table, value node, value user, value passwd){
  CAMLparam4(table,node,user,passwd);
  CAMLlocal1(cursor);
  // declaration avec type eleve
  init_ops();
  cursor=alloc_custom(ops,sizeof(comp_curs),0,1);
  create_comp_curs((comp_curs*)cursor,(char*)node,(char*)table,(char*)user,(char*)passwd);  
  CAMLreturn (cursor);
}

// Accede au tuple suivant du curseur.
// Sort par exception si plus de tuple.
// Retourne un tuple Caml sinon
CAMLprim value dbml_has_next_stub(value cursor) {
  CAMLparam1(cursor);
  //odbcCurs=(comp_curs*)Data_custom_val(cursor);  
  CAMLlocal2 (tuple,valret);
  tuple=alloc_string (256);
  tuple=(value)tuple_suivant((char*)tuple,(comp_curs*)cursor);
  valret=copy_string(tuple);
  CAMLreturn (valret);
}

// Les noms des attributs
CAMLprim value dbml_entetes_stub(value cursor) {
  CAMLparam1(cursor);
  CAMLlocal2(entete,valret);
  entete=alloc_string(256);
  entete=(value)odbc_entetes((char*)entete,(comp_curs*)cursor);
  valret=copy_string(entete);
  CAMLreturn(valret);
}


// Fin de la requete : Nettoyage de la base de donnes
CAMLprim value dbml_close_stub(value cursor) {
  CAMLparam1(cursor);
  // Va supprimer la table sur tous les sites ou elle est repartie
  //combiner les deux suivants
  //odbc_termine_requete();
  //odbc_deconnexion();
  //odbcCurs=(comp_curs*)Data_custom_val(cursor)
  //odbc_close_and_disconnect(odbcCurs->stmt,odbcCurs->conn);
  CAMLreturn (Val_unit);
}
