#include <stdlib.h>
#include <stdio.h>
#include <sql.h>
#include <sqlext.h>
#include <sqltypes.h>

struct conn_info_s {
  SQLHENV env;			// Handle ODBC environment
  SQLHDBC hdbc;			// Handle connection
};

typedef struct conn_info_s conn_info;

struct stmt_cols_s {
  SQLCHAR     *nom;
  SQLSMALLINT type;
  SQLPOINTER  data;
  SQLLEN      taille;
};

typedef struct stmt_cols_s stmt_cols;

struct comp_curs_s {
  conn_info * conn;
  SQLHSTMT * stmt;
  int nbcols;
  stmt_cols *cols;
  SQLINTEGER *lenbuff;
};

typedef struct comp_curs_s comp_curs;

void odbc_connexion(conn_info* conn, const char* source, const char* user, const char* passwd);

void odbc_deconnexion(conn_info* conn);

//int odbc_prepare_requete(conn_info* conn,SQLHSTMT* stmt, const char*requ, stmt_cols* cols, int nbcols) ;
int odbc_prepare_requete(comp_curs* cc, const char*requ) ;

int odbc_tuple_suivant(SQLHSTMT stmt) ;

void odbc_termine_requete(SQLHSTMT stmt) ;

int odbc_requete(conn_info* conn, const char* requ) ;

comp_curs * create_comp_curs(comp_curs * cc, char * node, char * table, char * user, char * passwd);

void close_comp_curs(comp_curs * cc);

char* odbc_entetes(char* entetes,comp_curs* cc);

void trace_structure(stmt_cols* cols,int nbc);
char * tuple_suivant(char* tuple,comp_curs * cc);
