#include "histbin.h"
#include <stdlib.h>
#include <sys/time.h>
#include <mpi.h>

int main(int* argc,char* argv[]){
  int num_procs;
  int myid;
  int nbval;
  int delta;
  int taillechaine=10;
  char* chaine=(char*)malloc(taillechaine);
  int i;
  HIST hist;
  HIST hist2;
  HIST hist3;
  HIST hist4;
  HIST_ARRAY* ha;
  HIST_ARRAY* hb;
  HIST_ARRAY* hc;
  HIST_ARRAY* hd;
  struct timeval t1,t2;
  struct timezone tz;
  int time1,time2,nbblocs1,nbblocs2;
  int nbblocs;
  HIST_ARRAY* ptr;
  HIST_ARRAY* new;
  MPI_Status status;



  MPI_Init(&argc,&argv);
  MPI_Comm_size(MPI_COMM_WORLD,&num_procs);
  MPI_Comm_rank(MPI_COMM_WORLD,&myid); 

  nbval=atoi(argv[1]);
  delta=atoi(argv[2]);
  //int taillechaine=atoi(argv[3]);

  if (myid==0) {
    //  printf("va initialiser\n");
    hist_init(&hist,8192,0,taillechaine+1,get_key,free_record);
    for (i=0;i<nbval;i++) {
      //printf("va ajouter %d\n",i);
      sprintf(chaine,"%d",i);
      hist_insert_frequency(&hist,chaine,random()%delta);
    }
      hist_init(&hist2,8192,0,taillechaine+1,get_key,free_record);
      //hist_init(&hist3,8192,0,taillechaine+1,get_key,free_record);
      
      gettimeofday(&t1,&tz);
      ha=HIST_to_HIST_ARRAY(&hist);
      
      for (ptr=ha,nbblocs=0;ptr!=NULL;ptr=ptr->next,nbblocs++);
      MPI_Send(&nbblocs,1,MPI_INT,1,0,MPI_COMM_WORLD);
      //i=0;
      for (ptr=ha;ptr!=NULL;ptr=ptr->next) {
	MPI_Send(ptr->data,HIST_BUFFER_SIZE,MPI_BYTE,1,0,MPI_COMM_WORLD);
	//printf("send %d de %d\n",++i,nbblocs);
      }
      
      MPI_Recv(&nbblocs,1,MPI_INT,1,0,MPI_COMM_WORLD,&status);
      ptr=NULL;
      for (i=0;i<nbblocs;i++) {
	ptr=ha_nouveau(ptr);
	MPI_Recv(ptr->data,HIST_BUFFER_SIZE,MPI_BYTE,1,0,MPI_COMM_WORLD,&status);
      }  
      HIST_ARRAY_to_HIST(ptr,&hist2);
      gettimeofday(&t2,&tz);
      
      time1=(t2.tv_usec-t1.tv_usec)+1e6*(t2.tv_sec-t1.tv_sec);
      nbblocs1=nbblocs;
    } else {
      hist_init(&hist2,8192,0,taillechaine+1,get_key,free_record);
      
      MPI_Recv(&nbblocs,1,MPI_INT,0,0,MPI_COMM_WORLD,&status);
      ptr=NULL;
      for (i=0;i<nbblocs;i++) {
	ptr=ha_nouveau(ptr);
	MPI_Recv(ptr->data,HIST_BUFFER_SIZE,MPI_BYTE,0,0,MPI_COMM_WORLD,&status);
	//printf("recv %d de %d\n",i+1,nbblocs);
      }  
      HIST_ARRAY_to_HIST(ptr,&hist2);
      hb=HIST_to_HIST_ARRAY(&hist2);
      
      for (ptr=hb,nbblocs=0;ptr!=NULL;ptr=ptr->next,nbblocs++);
      MPI_Send(&nbblocs,1,MPI_INT,0,0,MPI_COMM_WORLD);
      for (ptr=hb;ptr!=NULL;ptr=ptr->next) {
	MPI_Send(ptr->data,HIST_BUFFER_SIZE,MPI_BYTE,0,0,MPI_COMM_WORLD);
      }
    }
    
    MPI_Barrier(MPI_COMM_WORLD);
    
    if (myid==0) {
      hist_init(&hist3,8192,0,taillechaine+1,get_key,free_record);
      gettimeofday(&t1,&tz);
      //ha=HIST_to_HIST_ARRAY(&hist);
      hist_array_buffer(&hist,&hc);
      for (ptr=hc,nbblocs=0;ptr!=NULL;ptr=ptr->next,nbblocs++);
      MPI_Send(&nbblocs,1,MPI_INT,1,0,MPI_COMM_WORLD);
      for (ptr=hc;ptr!=NULL;ptr=ptr->next) {
	MPI_Send(ptr->data,strlen(ptr->data)+1,MPI_CHAR,1,0,MPI_COMM_WORLD);
	//printf("%d\n",strlen(ptr->data)+1);
      }
      //printf("fin envoi 0 a 1\n");
      MPI_Recv(&nbblocs,1,MPI_INT,1,0,MPI_COMM_WORLD,&status);
      ptr=NULL;
      for (i=0;i<nbblocs;i++) {
	new=(HIST_ARRAY *)malloc(sizeof(HIST_ARRAY));
	new->data=(char*)malloc(HIST_BUFFER_SIZE);
	new->next=ptr;
	ptr=new;
	//ptr=ha_nouveau(ptr);
	MPI_Recv(ptr->data,HIST_BUFFER_SIZE,MPI_BYTE,1,0,MPI_COMM_WORLD,&status);
      }  
      //HIST_ARRAY_to_HIST(ptr,&hist2);
      hist_load_array_buffer(ptr,&hist3,8192,0,taillechaine+1,get_key,free_record);
      
      gettimeofday(&t2,&tz);
      
      time2=(t2.tv_usec-t1.tv_usec)+1e6*(t2.tv_sec-t1.tv_sec);
      nbblocs2=nbblocs;
    } else {
      //hist_init(&hist4,8192,0,taillechaine+1,get_key,free_record);
      
      MPI_Recv(&nbblocs,1,MPI_INT,0,0,MPI_COMM_WORLD,&status);
      ptr=NULL;
      for (i=0;i<nbblocs;i++) {
	//printf("avant recv\n");
	new=(HIST_ARRAY *)malloc(sizeof(HIST_ARRAY));
	new->data=(char*)malloc(HIST_BUFFER_SIZE);
	new->next=ptr;
	ptr=new;
	MPI_Recv(ptr->data,HIST_BUFFER_SIZE,MPI_BYTE,0,0,MPI_COMM_WORLD,&status);
	//printf("apres recv\n");
      }  
      
      //HIST_ARRAY_to_HIST(ptr,&hist2);
      //printf("avant load\n");
      hist_load_array_buffer(ptr,&hist4,8192,0,taillechaine+1,get_key,free_record);
      //printf("apres load\n");
      //hb=HIST_to_HIST_ARRAY(&hist2);
      hist_array_buffer(&hist4,&hd);
      //printf("apres buffer\n");
      for (ptr=hd,nbblocs=0;ptr!=NULL;ptr=ptr->next,nbblocs++);
    MPI_Send(&nbblocs,1,MPI_INT,0,0,MPI_COMM_WORLD);
    for (ptr=hd;ptr!=NULL;ptr=ptr->next) {
      MPI_Send(ptr->data,strlen(ptr->data)+1,MPI_BYTE,0,0,MPI_COMM_WORLD);
    }
  }
  /*  for (ptr=ha,nbblocs=0;ptr!=NULL;ptr=ptr->next,nbblocs++);
  printf("temps : %d  blocs : %d\n",time,nbblocs);
  
  
  gettimeofday(&t1,&tz);
  hist_array_buffer(&hist,&hb);
  hist_load_array_buffer(hb,&hist3,8192,0,taillechaine+1,get_key,free_record);
     
  //  HIST_ARRAY_to_HIST(hb,&hist3);
  gettimeofday(&t2,&tz);

  time=(t2.tv_usec-t1.tv_usec)+1e6*(t2.tv_sec-t1.tv_sec);
  for (ptr=hb,nbblocs=0;ptr!=NULL;ptr=ptr->next,nbblocs++);
  printf("temps : %d  blocs : %d\n",time,nbblocs);

  */

    MPI_Barrier(MPI_COMM_WORLD);

    if (myid==0) {
      printf("%d %d %d %d\n",time1,nbblocs1,time2,nbblocs2);
    }
  MPI_Finalize();

  return 1;
}
