#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "hist.h"


#define MAX_RECORDS 10000
#define MAX_KEYS 3


static int rnd(int max_value);

static uint testflag=0,recant=100,reclength=37;
static ulong key1[1000];

/* Ge ett randomv{rde inom ett intervall 0 <=x <= n */

static int rnd(int max_value)
{
  return (int) ((rand() & 32767)/32767.0*max_value);
} /* rnd */

char* get_key2(const char *key,uint *length)
{
 *length=strlen(key);
 return (char*) key;
}

char *hist2_key(const char *rec,uint *length)
{
  *length=(uint) (uchar) rec[reclength-1];
  return (char*) rec;
}

int local_histogram_array_buffer_distribution(hist,adlist,nprocs,myid)
     HIST *hist;
     HIST_ARRAY **adlist;
     int nprocs,myid;
     
{ 
  HIST_LINK   *data;
  HIST_ARRAY  ptr,
              *list;
  char        **buffer,record[80],*entry;
  int        i,id,records,*length,reclength=0;
  
 
  length=(int*) malloc(nprocs*sizeof(int));
  buffer= (char**) malloc(nprocs*sizeof(char*));
  list=(HIST_ARRAY*)  malloc(nprocs*sizeof(HIST_ARRAY));
  
  for (i=0 ; i < nprocs ; i++){
        list[i]=0; 
        length[i]=0;
        buffer[i]= (char*) malloc(HIST_BUFFER_SIZE*sizeof(char));
  }
  // printf("Line : %d %d \n", myid,__LINE__); 
  if (hist) {
      data=array_dynamic_element(&hist->array,0,HIST_LINK*);
      records=hist->records;
      for (i=0 ; i < records ; i++) {
               sprintf(record,"%s %d %d\n",data[i].data,data[i].freq,myid);
               reclength=strlen(record); 
               id=(atoi(data[i].data)) % nprocs;
	       if ((length[id]+reclength)>= HIST_BUFFER_SIZE) { 
                   ptr=(HIST_ARRAY) malloc(sizeof(struct st_hist_array));
                   if (ptr==0)
                       {
			 printf(" No enough memory ...\n");
                         return(0);
                       }
                   entry=(char*) malloc(length[id]+1);
                   memcpy(entry,buffer[id],length[id]); entry[length[id]]=0;
                   ptr->data=entry;
                   ptr->next=list[id];
                   list[id]=ptr;
                   length[id]=0;
                 }
               memcpy(buffer[id]+length[id],record,reclength); length[id]+=reclength;
      }
     
   for (i=0 ; i < nprocs ; i++){
      if (length[i]!=0) {
                 ptr=(HIST_ARRAY) malloc(sizeof(struct st_hist_array));
                 if (ptr==0)  {
			 printf(" No enough memory ...\n");
                         return(0);
                 }
                 entry=(char*) malloc((length[i]+1)*sizeof(char));
                 memcpy(entry,buffer[i],length[i]); entry[length[i]]=0;
                 ptr->data=entry;
                 ptr->next=list[i];
                 list[i]=ptr; 
                 length[i]=0; reclength=0;
                 free(buffer[i]); 
      }
   }
  }
  free(buffer); free(length); 
  *adlist = list;
  return(1);

}






















		/* Huvudprogrammet */

int main(int argc,char *argv[])
{
  register uint i,j,k;
  uint n=0,n1,n2,n3;
  uint write_count,update,delete;
  ulong pos;
  unsigned long key_check;
  char *record,*record1,*recpos,oldrecord[120], entry[40],key[120],*chaine;
  time_t debut, fin;
  HIST hist,lhist, hist2,hist3,hist4,hist5;
  HIST_ARRAY list;
  
 
  write_count=update=delete=0;
  key_check=0;
  bzero(key1,sizeof(key1[0])*1000);

  printf("- Creating hist\n");
  time(&debut);
  if (hist_init(&hist,recant,0,0,get_key,free_record))
       printf("- Creating hist Error ....\n");

  
    for (i=0;i<MAX_RECORDS;i++) {
        j= rand() % (MAX_RECORDS*100); 
        sprintf(entry,"%dAA",i);
        hist_insert_frequency(&hist,entry,i);
    }

    
    time(&fin);
    printf("temps d'execution 1 : %f\n", difftime(fin,debut));
    hist_array_buffer(&hist,&list,&n);
    //hist_array_buffer_show(list);


    /*
    if (hist_init(&lhist,recant,0,6,0,free_record))
             printf("- Creating hist Error ....\n");
    */


    if (hist_load_array_buffer(list,&lhist,recant,0,0,get_key,free_record)==0)
        printf("- LOAD ARRAY BUFFER NOT DONE ....\n");
    printf("\n tapper un nombre pour la suite  ... \n"); scanf("%d",&n);
    printf("@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ HIST\n");
    hist_show_file(&hist,"hist.data");
      printf("@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ buffer HIST\n");
    hist_show_file(&lhist,"lhist.data");
     if (hist_comp(&hist,&lhist)==1)
          printf(" ARRAY BUFFER HISTOGRAMS ARE IDENTICAL ...\n");
    else  printf(" ARRAY BUFFER NOT IDENTICAL ...\n");
    
    printf("\n tapper un nombre pour la suite  ... \n"); scanf("%d",&n);
    hist_array_buffer_free(&list);  
    hist_array_buffer_show(list);
    hist_free(&lhist);    

    sprintf(entry,"%dAA",j);   
    for (i=0;i<MAX_RECORDS*10;i++) {
           if (hist_search(&hist,entry,0)) n++;  
    }
    
    time(&debut);
    printf("temps d'execution 2 : %f, n : %d \n", difftime(debut,fin),n);
    printf("- Histogam free call:\n");
    hist_show(&hist); 
    hist_free(&hist);
    hist_show(&hist); 
  if (hist_init(&hist,recant,0,36,0,free_record))
       printf("- Creating hist Error ....\n");
  printf("- Writing records:\n");
 
  for (i=1 ; i <= recant ; i++)
  {
    n1=rnd(100); n2=rnd(100); n3=rnd(min(recant*5,MAX_RECORDS));
    sprintf(entry,"%6d:%4d:%8d:Pos: %4d      ",i,n2,n3,write_count);
    for (j=0;j<i; j++)
    if (hist_insert(&hist,entry))
    {
      printf("Error in write at record: %d\n",i);
    }
  
    key1[n1]++;
    key_check+=n1;
    write_count++;
  }
  for (i=0 ;i< MAX_RECORDS;i++)
  if (hist_insert(&hist,entry)) printf("\n element non insere");
   hist_show(&hist);

  printf("\n la donnees (hist) ayant la position 41 est : %s\n",hist_element(&hist,41));
  i=8;
  sprintf(key,"%6d",i);
  chaine=hist_search(&hist,key,6);
  printf("\n  l'enregistrement associe a la clee  %s : %s",key,chaine);
  j=0;
  while (chaine=hist_next(&hist,key,6))
     printf("\n  l'enregistrement associe a la clee  %s  (%d suivant): %s",key,++j,chaine); 
  printf("\n  ######## HISTOGRAMME 1 ################");      
  hist_show(&hist);  
  printf("\n la taille de l'histograme est         : %d",hist.records);
  
  printf("\n la donnees (hist) ayant la position 41 est : %s\n",hist_element(&hist,41));
  printf("\n la donnees (hist) ayant la position 42 est : %s\n",hist_element(&hist,42));
  
  
   printf("- Delete\n");
   for (i=0 ; i < write_count/10 ; i++)
   {
     for (j=rnd(100) ; j>0 && key1[j] == 0 ; j--) ;
     if (j != 0)
     {
       sprintf(key,"%6d",j);
       if (!(recpos=hist_search(&hist,key,6)))
       {
	  printf(" can't find key1: \"%s\"\n",key);
       } else
	 {
            key1[atoi(recpos)]--;
            key_check-=atoi(recpos);
            reclength=strlen(recpos)+1;
            memcpy(oldrecord,recpos,reclength); 
            if (hist_delete(&hist,recpos))
               {
	          printf(" error: can't delete record: \"%s\"\n",oldrecord);
               }
             delete++;
           if (testflag == 2 )
            {
        	puts("Heap keys crashed");
            }
         }
     }
   }
  
  printf("- Update\n");
  for (i=0 ; i < write_count/10 ; i++)
  {
    n1=rnd(1000); n2=rnd(100); n3=rnd(min(recant*2,MAX_RECORDS));
    for (j=rnd(1000) ; j>0 && key1[j] == 0 ; j--) ;
    if (j)
    {
      sprintf(key,"%6d",j);
      if (!(recpos=hist_search(&hist,key,6)))
      {
	printf("can't find key1: \"%s\"\n",key);
	
      }
      else {
         key1[atoi(recpos)]--;
         key_check=key_check-atoi(recpos)+n1;
         key1[n1]++;
         sprintf(recpos,"%6d:%4d:%8d:XXX: %4d      ",n1,n2,n3,update);
         update++;
         if (hist_update(&hist,recpos,key,6))
         {
	   printf("can't update key1: \"%s\"\n",key);
	
         }
         if (testflag == 3)
         {
	  printf("Heap keys crashed for %d update\n",update);
	
         }
       }
    }
  }
  hist_show(&hist);
  
  printf("\n la taille de l'histograme est         : %d\n",hist.records);
    
  printf(" la donnees (hist) ayant la position 41 est : %s\n",hist_element(&hist,41));
  printf(" la donnees (hist) ayant la position 42 est : %s\n",hist_element(&hist,42));



  for (j=0 ; j < 1000 ; j++)
    if (key1[j] > 1)
      break;
  if (key1[j] > 1)
  {
    printf("- Testing identical read\n");
    sprintf(key,"%6d",j);
    pos=1;
    if (!(recpos=hist_search(&hist,key,6)))
    {
      printf("can't find key1: \"%s\"\n",key);
     
    }
    while (hist_next(&hist,key,6) && pos < (ulong) (key1[j]+10))
      pos++;
    if (pos != (ulong) key1[j])
    {
      printf("Found %d copies of key: %s. Should be %d\n",pos,key,key1[j]);
     
    }
  }
  
  printf("- Creating output heap-file 2\n");
  if (hist_init(&hist2,hist.records,0,0,hist2_key,free_record))
     printf("- Creating output heap-file2 Error ... \n");
 

   printf("\n  ######## HISTOGRAMME ################\n");
   hist_show(&hist);
   if (hist_copy(&hist,&hist3))  {
      printf("\n  ######## HISTOGRAMME 3 (copy ) ################\n");
      hist_show(&hist3);
    }
  if (hist_select(&hist3,60,&hist4)){
      printf("\n  ######## HISTOGRAMME Select 3 (merge) ################\n");
      hist_show(&hist4);
    }
  if (hist_intersect(&hist,&hist4,&hist5)){
      printf("\n  ######## HISTOGRAMME intesect (merge) ################\n");
      hist_show(&hist5);
  }
  if (hist_comp(&hist,&hist3))
      printf("\n   HISTOGRAMME  1 and 3 identical ...................\n");
  else  printf("\n   HISTOGRAMME  1 and 3 are not  identical ...................\n");
  
  if (hist_comp(&hist5,&hist5))
      printf("\n   HISTOGRAMME  5 and 5 identical ...................\n");
  else  printf("\n   HISTOGRAMME  5 and 5 are not  identical ...................\n");
  if (hist_comp(&hist,&hist5))
      printf("\n   HISTOGRAMME  1 and 5 identical ...................\n");
  else  printf("\n   HISTOGRAMME  1 and 5 are not  identical ...................\n");
 
  

 printf("- Copying and removing records\n");

   pos=0;
  while (recpos=hist_element(&hist,0))
  {
    // record=(char*) malloc(reclength);
    //memcpy(record,recpos,reclength);
    //record[reclength-1]=rnd(5)+1;
    if (hist_insert(&hist2,recpos))
    {
      printf("Got error when inserting record: %s\n",recpos);
    }
    key_check-=atoi(recpos);
    write_count++;
    if (hist_delete(&hist,recpos))
    {
      printf("Got error when deleting record: %s\n",recpos);     
    }
    pos++;
  }

  if (key_check != 0)
  {
    printf("Key check didn't get to 0 (%d)\n",key_check);
  }
  
 
  printf("\n  ######## ################");
  

  printf("\nFollowing test have been made:\n");
  printf("Write records: %d\nUpdate records: %d\nDelete records: %d\n", write_count, update,delete);
  hist_free(&hist); hist_free(&hist2); hist_free(&hist3);
  return(0);

} /* main */


