#include "pdbml.h"


int main(argc,argv)
int argc;
char *argv[];
{  

  MYSQL       *sock,connect;	
  __String     name, db_name,table,processor_name;

  uint        num_procs,id, myid,nodes_id[Max_nodes],namelen,             
              nbucket,threshold,idx,param,count; 

  double      startwtime, endwtime,loc_time;  

  query_list  *requetes, *curr_req;
  list_sql2   *curr_op;
  
  char fich[100], fich_sql[100],
       *buf, user_name[32],password[32], db[32], host_name[32], join_type[32];   


  int JOIN_ALGO=OSFA_JOIN;   //Algorithme de jointure par defaut

 	           	
  MPI_Init(&argc,&argv);
  MPI_Comm_size(MPI_COMM_WORLD,&num_procs);
  MPI_Comm_rank(MPI_COMM_WORLD,&myid); 
  MPI_Get_processor_name(processor_name,&namelen);

  // Appel initial a getNodeRank pour avoir le mapping entre nom de machine et rang du noeud mpi
  //printf("appel getNodeRank...\n");
  getNodeRank(NULL);


      if ((argc<2)||(argc>4))  {
	 if (myid == 0){
             fprintf(stderr,"\n usage : mpirun -np nprocs join_test <dbname> <queryfile> [ OSFA | THREAD_OSFA| PIPE_OSFA | SFA | FA | HASH | ALL ] \n"); 
	 }
         MPI_Finalize(); 
	 exit(1);
       }
       if (myid == 0) {
           fprintf(stderr," Processes number : %d \n",num_procs);
           fprintf(stderr," Processor name : %s \n",processor_name);
           fprintf(stderr," Database name    : %s\n", argv[1]);     
           startwtime = MPI_Wtime(); 
       }

       strcpy(fich,"info.db");
       strcpy(db_name,argv[1]);
       strcpy(fich_sql,argv[2]);
           
       if (argc==4)
	 { strcpy(join_type,argv[3]);
	   if (strcasecmp(join_type,"THREAD_OSFA")==0)       JOIN_ALGO=THREAD_OSFA_JOIN;
	   else if (strcasecmp(join_type,"PIPE_OSFA")==0)    JOIN_ALGO=PIPE_OSFA_JOIN;
	   else if (strcasecmp(join_type,"SFA")==0)          JOIN_ALGO=SFA_JOIN;     
           else if (strcasecmp(join_type,"FA")==0)           JOIN_ALGO=FA_JOIN;
           else if (strcasecmp(join_type,"HASH")==0)         JOIN_ALGO=HASH_JOIN; 
	   else if (strcasecmp(join_type,"ALL")==0)          JOIN_ALGO=ALL_JOINS;        
	 }
       //printf ("debut init_hosts sur %d\n",myid);
  init_hosts(host,NODES_CONFIG_FILE,&NODES_NUMBER);
  id=host_id(processor_name);
  MPI_Allgather(&id,1, MPI_INT,nodes_id,1,MPI_INT,MPI_COMM_WORLD); 
  //printf ("fin init_hosts sur %d\n",myid);

  mysql_port=(host+id)->port;
  strcpy(user_name,(host+id)->username);
  strcpy(password,(host+id)->password);
  strcpy(host_name,(host+id)->name); 

  session.user=user_name;
  session.password=password;
  session.host=host_name; 
  session.dbase=db_name;  
 
  if  ((connect_start(&session,&connect))==0) {
            printf(" \n Echec initialisation .....\n");
            MPI_Finalize(); 
            exit(1); 
     }
  sock=&connect;
  //printf("\n Connection BD OK sur %d...\n",myid);
  /**************************************************************************/
  drop_all_temporary_tables(TEMPORARY_TABLE_NAME, sock); 
  MPI_Barrier(MPI_COMM_WORLD);
  /*************************** osfa_join tests *******************************/

  idx=(num_procs>8)?4*num_procs:8*NODES_NUMBER;
  nbucket=1; threshold=idx*num_procs;
  MPI_Barrier(MPI_COMM_WORLD);
   
  requetes=parser(fich_sql,fich);
  MPI_Barrier(MPI_COMM_WORLD);
  //printf("\n");
  // printf("\n***************************************************************************************************\n");
  // show_sql_queries(requetes);    
  //printf("\n***************************************************************************************************\n");
  
  MPI_Barrier(MPI_COMM_WORLD);
 
  //printf("debut exec sur %d\n",myid);
  if (JOIN_ALGO==ALL_JOINS) { 

       // //////////////////// osfa join test  /////////////////////////////  
       loc_time = join_queries(requetes,threshold,num_procs,myid,nodes_id,sock,MPI_COMM_WORLD,hash_string,OSFA_JOIN);

       // //////////////////// pipelined osfa join test  /////////////////////////////  
       MPI_Barrier(MPI_COMM_WORLD);
       loc_time =  join_queries(requetes,threshold,num_procs,myid,nodes_id,sock,MPI_COMM_WORLD,hash_string,PIPE_OSFA_JOIN);

                     
       // //////////////////// osfa thread join test  /////////////////////////////  
       MPI_Barrier(MPI_COMM_WORLD);
       loc_time =  join_queries(requetes,threshold,num_procs,myid,nodes_id,sock,MPI_COMM_WORLD,hash_string,THREAD_OSFA_JOIN);

       // //////////////////// sfa join test  /////////////////////////////  
       MPI_Barrier(MPI_COMM_WORLD);
       loc_time =  join_queries(requetes,threshold,num_procs,myid,nodes_id,sock,MPI_COMM_WORLD,hash_string,SFA_JOIN);
 
       // //////////////////// fa join test  /////////////////////////////  
       MPI_Barrier(MPI_COMM_WORLD);
       loc_time = join_queries(requetes,threshold,num_procs,myid,nodes_id,sock,MPI_COMM_WORLD,hash_string,FA_JOIN);
 
       // //////////////////// hash join test  ///////////////////////////// 
       MPI_Barrier(MPI_COMM_WORLD);  
       loc_time = join_queries(requetes,threshold,num_procs,myid,nodes_id,sock,MPI_COMM_WORLD,hash_string,HASH_JOIN);
  }
  else loc_time = join_queries(requetes,threshold,num_procs,myid,nodes_id,sock,MPI_COMM_WORLD,hash_string,JOIN_ALGO);

  mysql_close(sock);     
  MPI_Finalize(); 
}
