#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <libxml/xmlmemory.h>
#include <libxml/parser.h>

#include "common.h"
#include "infostables.h"
#include "bloc.h"

void addAttributes(info_table* uneTab, char* fileName) { 
  int  i=0 ; 
  char nam[32] ; 
  char ali[32] ; 
  char typ[32] ;
  FILE *fd ;
  
  if ((fd = fopen(fileName, "rt")) == NULL) {
    fprintf(stderr, "\nOpen attributes file %s failled !!!", fileName) ;
    exit(1) ;
  }

  while (fscanf(fd, "%s %s %s", nam, ali, typ) != EOF) {
    if ((strchr(nam, '#') == NULL) && (i < NBMAXATTRS)) {  
      char* name = (char*)malloc(sizeof(nam)) ;
      strcpy(name, nam) ;
      char* alias = (char*)malloc(sizeof(ali)) ;
      strcpy(alias, ali) ;
      char* type = (char*)malloc(sizeof(typ)) ;
      strcpy(type, typ) ;
      addAttr(uneTab, createAttr(name, alias, type)) ;
      i++ ;
    }
  } 
}

void addNodes(info_table* uneTab, char* fileName) { 
  int  i=0 ; 
  char nam[32] ; 
  char nbtup[32] ; 
  char siz[32] ;
  FILE *fd ;

  if ((fd = fopen(fileName, "rt")) == NULL) {
    fprintf(stderr, "\nOpen nodes file %s failled !!!", fileName) ;
    exit(1) ;
  }

  while (fscanf(fd, "%s %s %s", nam, nbtup, siz) != EOF) {
    if ((strchr(nam, '#') == NULL) && (i < NBMAXNODES)) {  
      int nbtuples = atoi(nbtup) ;
      int size = atoi(siz) ;
      char* name = (char*)malloc(sizeof(nam)) ;
      strcpy(name, nam) ;
      addNode(uneTab, createNode(name, nbtuples, size)) ;
      i++ ;
    }
  } 
}

main(int argc, char* argv[]) {
  
  if (argc != 7) {
    printf("Usage addtable <tablename> <basename> <attributes_file> <nodes_file> <input_xml_file> <output_xml_file>\n");
    exit(1) ;
  }
  
  info_tables* it = getInfoTables(argv[5]) ;
  info_table* uneTab = createTable(argv[1], argv[2], "", 0, 0, 0, 0, NULL, 0, NULL) ;
 
  addAttributes(uneTab, argv[3]) ;
  addNodes(uneTab, argv[4]) ;
  
  addTable(it, uneTab) ;
  
  writeInfoTables(argv[6], it) ;

  exit(0) ;
}
