#include <mpi.h>

/**************** Gestion des correspondances entre nom de machine et numero MPI
 retourne le rang de la machine "nodename" dans MPI_COMM_WORLD
 retourne -1 si introuvable
 ATTENTION
 le premier appel permet l'initialisation (la liste est statique) et retourne le nombre de noeuds
*********************************************************************************/
int getNodeRank(char *nodename) {
  static char **tab; // la liste des noeuds. On doit pouvoir ameliorer avec une table hachage... il faudrait aussi prevoir un free...
  static int num_procs=0; // le nombre de noeuds
  int i;
  int myid;
  int namelen;

  if (num_procs==0) { // premier appel : 
    // recup des infos locales
    MPI_Comm_size(MPI_COMM_WORLD,&num_procs);
    // on suppose que la taille des noms de machine est <40
    tab=(char**)malloc(sizeof(char*)*num_procs);
    for (i=0;i<num_procs;i++) {
      tab[i]=(char*)malloc(sizeof(char)*40);
    }

    MPI_Comm_rank(MPI_COMM_WORLD,&myid);
    MPI_Get_processor_name(tab[myid],&namelen);

    // echange des infos
    for (i=0;i<num_procs;i++) {
      MPI_Bcast(tab[i],40,MPI_CHAR,i,MPI_COMM_WORLD);
    }
    return num_procs;
  } else { // fonctionnement normal
    i=0;
    while ((i<num_procs) && (strcasecmp(nodename,tab[i]))) {
      i++;
    }
    if (i<num_procs) {
      return i;
    } else {
      return -1;
    }
  }
}
