#ifndef PARSERH

#include <stdio.h>
#include <string.h>

 
/* des definitions ajoutees par matthieu pour rendre les types d'op. plus lisibles ... */
#define OP_JOIN_SIMPLE 1
#define OP_JOIN 1
#define OP_JOIN_MULTI 2
#define OP_SELECT 3
#define OP_SCHEMA 10

extern char *types_op[];
/* fin matthieu */

#define MAX_ATTR 20 /* nombre max d'attributs dans un tableau d'attributs (utilise dans list_sql2) */
char nom_fich[100];
struct list_nom {
char *nom ;
struct list_nom  *suivant;
};

typedef struct list_nom list_nom;

struct _list_sql2 { 
  char *table1;    /* 1ere table de la jointure */
  char *table2;    /* 2eme table de la jointure */
  char *at1;       /* attribut joint de la 1ere table */
  char *at2;       /* attribut joint de la 2eme table */
  int nbnodes1;    /* nombre de noeuds contenant des fragments de table1 */
  int *nodes1;     /* liste de ces noeuds */
  int nbnodes2;    /* nombre de noeuds contenant des fragments de table2 */
  int *nodes2;     /* liste de ces noeuds */
  int nbnodesD;    /* nombre de noeuds contenant des fragments de la table resultat */
  int *nodesD;     /* liste de ces noeuds */
  char *op_join;   /* operateur de jointure (=,>,etc.) */
  char **at1_res;  /* liste des attributs de table1 apparaissant dans le resultat */
  char **al1_res;  /* liste des alias corespondants (si besoin) */
  char **at2_res;  /* liste des attributs de table2 apparaissant dans le resultat */
  char **al2_res;  /* liste des alias corespondants (si besoin) */
  int nb_at1_res;  /* nombre des attributs de table1 apparaissant dans le resultat */
  int nb_at2_res;  /* nombre des attributs de table2 apparaissant dans le resultat */
  char *tableres;  /* le nom de la table temporaire ou on stocke le resultat de l'op. (s'il y a lieu) */
  int type;        /* type de la requete a laquelle appartient cette operation */ 
  char *machine;
  char *requete_sql;  /* l'operation sous forme sql */
  int todelete;       /* indique la table en entree qui est une table temporaire */
  int tosave;
  struct _list_sql2 *suivant1;  
  struct _list_sql2 *suivant2;   // inutilise pour l'instant dans la nouvelle version 
  struct _list_sql2 *precedent;  // utilisee pour l'instant dans la version version pipelinee
  int                pipe_tab ;       // numero de la relation qui est pipelinee  (0 si pas de pipeline, 1 ou 2)
  int                pipe_next;       // Numero de la relation pipelinee dans sql_next_query, 
                                      // pipe_next prend la valeur
                                      // 0 si le resultat de la jointure courante  n'est pas une operande pour la jointure suiv. 
                                      // 1 si le resultat de la jointure courante  est l'operande 1 pour la jointure suiv. 
                                      // 2 si le resultat de la jointure courante  est l'operande 2 pour la jointure suiv.       
  char               pipe_attr[128];  // attribut de jointure de la relation  pipeline
  int                pipe_attr_tab ;  // numero de la relation contenant l'attribut de jointure  de la jointure suivante (0 si pas de pipeline, 1 ou 2)
  void              *hist_pipe_tree;       //
  unsigned int      hist_key_length ; 
    //void             **hist_pipe_list;  
    //void             **hist_pipe_tree_list; 
  void*              commEnv;         // CommEnv est en fait  un commEnv est de type comms mais je passe par l'intermedaire de void* pour ...
  int                typeComm;
};

typedef struct _list_sql2 list_sql2;

// la liste des requetes ...
typedef struct _query_list {
  list_sql2 *query;
  int nbq;
  struct _query_list* next;
} query_list;

/*
struct _list_sql {
  char *attributs;
  char *table;
  char *tableres; // le nom de la table temporaire ou on stocke le resultat de l'op. (s'il y a lieu)
  int type;
  char *machine;
  char *requete_sql;
  char *op_join;
  struct _list_sql *suivant1;
  
  char *at1;
  char *at2;
  struct _list_sql *suivant2;
};

typedef struct _list_sql list_sql;
*/
struct attribut {
  char *att1;
  char *att2;
  char *op_join;
  struct attribut *suivant;
};




list_nom *alloue(char *attribut);
list_nom *info3(char *table, char *chaine_entree);
//struct attribut * test4(char *where_at,int *type_w );
//list_sql  *alloue_sql(char *attributs, char *table,char *requete_sql, char *machine,int where_type, char *where_att,int where_exist);
query_list *insere(query_list *tete, list_sql2 *req);
//list_sql *join_decompose(struct attribut *list1, char *select_att);

//void add_attr_res(int num_table,list_sql *query, char *attr);
char *info1(char *nom_fich);
int info2(char *att,char *table, char *chaine_entree);
void info4(char *car, char *table);
int info5(list_nom *llist, char *at);
char *nouvTable (list_nom *llist);
char *info7(char *car);
list_nom *info8(char *car);
char *info9(char *select_att, char *from_att, char *nom_fich);
query_list *parser(char *fich_sql,char *fich);
//void set_sql_query(list_sql * query);
//void set_sql_queries(list_sql * query);
/* transforme une liste de requetes du format list_sql au format list_sql2 */
//list_sql2 *type2(list_sql* liste1);
void trace_list_sql2(list_sql2 *req);
//void trace_list_sql(list_sql *req);
//void trace_tout(list_sql *liste);

#define PARSERH
#endif
