#ifndef SUBSITE_DEFS

#include <mpi.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>
#include "parser.h"


#define SOURCE1 1
#define SOURCE2 2
#define DEST 4

typedef struct comms_s{
  MPI_Comm src1;	// le communicateur de source 1 (necessaire ?)
  MPI_Comm src2;	// le communicateur de source 2 (necessaire ?)
  MPI_Comm src;	// le communicateur des sources
  MPI_Comm dst;	// le communicateur des dest (sites de jointure)
  MPI_Comm sd;	// le communicateur global (pour la transition entre phase s et phase d)
  uint nbnodes1; // nombre et liste des noeuds source 1
  int  *nodes1;
  int myid1;
  uint nbnodes2; // nombre et liste des noeuds source 2
  int  *nodes2;
  int myid2;
  uint nbnodesS; // nombre et liste des noeuds source (1 ou 2)
  int  *nodesS;
  int myidS;
  uint nbnodesD; // nombre et liste des noeuds destinataires
  int  *nodesD;
  int myidD;
  uint nbnodesSD; // nombre de noeuds source ou destinataire
  int *nodesSD;
  int myidSD;
}comms;

void copietab(int *t1,int r1,int *t2,int r2,int nb);
int merge(int nb1,int *nodes1,int nb2,int *nodes2,int** nodes);
int intab(int val,int *tab,int n);
// Retourne 1 si le noeud est destinataire, 0 sinon
int isDest(int id,comms* c);
int getComms(list_sql2 *op,comms* c,int id);


#define SUBSITE_DEFS
#endif
